.model small,c
.386
.stack
.nolist
include support.asm
.list
.data
    biosErrorCode db 0
    buffer        db 512 dup(0)
.code
.startup

    push ds
    pop es

    ; Make up to 4 tries to read the boot sector of the first
    ; diskette drive, resetting the drive between attempts.

    mov cx, 4
    .WHILE cx
      push cx
      mov ah, 2               ; function Read Sectors
      mov al, 1               ; number of sectors to read
      mov ch, 0               ; low 8 bits of cylinder number
      mov cl, 1               ; sector number
      mov dh, 0               ; head number
      mov dl, 0               ; drive number
      mov bx, OFFSET buffer   ; ES:BX -> buffer
      int 13h
      mov biosErrorCode, ah
      jc  @F
      pop cx
      .BREAK                  ; success
    @@:
      mov ah, 0               ; function Reset Disk
      mov dl, 0               ; drive number
      int 13h
      pop cx
      dec cx
    .ENDW
    .IF cx == 0
      print "BIOS Error ",hexbyte$(biosErrorCode),"h",NL
      call waitkey
      .exit
    .ENDIF

    invoke dumpmem,ds,ADDR buffer,16
    call waitkey
    invoke dumpmem,ss,ADDR buffer+256,16
    call waitkey
    .exit
end
